# ***********************************************
# 
# !!!! DO NOT EDIT !!!!
# 
# This file was auto-generated by Build.PL.
# 
# ***********************************************
# 
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

=encoding utf8

=head1 NAME

Lucy::Search::ANDQuery - Intersect multiple result sets.

=head1 SYNOPSIS

    my $foo_and_bar_query = Lucy::Search::ANDQuery->new(
        children => [ $foo_query, $bar_query ],
    );
    my $hits = $searcher->hits( query => $foo_and_bar_query );
    ...

=head1 DESCRIPTION

ANDQuery is a composite L<Query|Lucy::Search::Query> which matches
only when all of its children match, so its result set is the intersection
of their result sets.  Documents which match receive a summed score.

=head1 CONSTRUCTORS

=head2 new

    my $foo_and_bar_query = Lucy::Search::ANDQuery->new(
        children => [ $foo_query, $bar_query ],
    );

Create a new ANDQuery.

=over

=item *

B<children> - An array of child Queries.

=back

=head1 METHODS

=head2 make_compiler

    my $compiler = $and_query->make_compiler(
        searcher    => $searcher     # required
        boost       => $boost        # required
        subordinate => $subordinate  # default: false
    );

Abstract factory method returning a Compiler derived from this Query.

=over

=item *

B<searcher> - A Searcher.

=item *

B<boost> - A scoring multiplier.

=item *

B<subordinate> - Indicates whether the Query is a subquery (as
opposed to a top-level query).  If false, the implementation must
invoke L<normalize()|Lucy::Search::Compiler/normalize> on the newly minted Compiler object before returning
it.

=back

=head1 INHERITANCE

Lucy::Search::ANDQuery isa L<Lucy::Search::PolyQuery> isa L<Lucy::Search::Query> isa Clownfish::Obj.

=cut

